#!/usr/local/bin/perl -wT
# Copyright Andru Luvisi, 1999
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program (see the file COPYING); if not, write to the
# Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA


use CGI;
use CGI::Carp qw(fatalsToBrowser);
use HTML::Template;
use strict;

use vars qw($query $template $spelltype @attrnames %attributes);
use vars qw(@templates $/ @candidates @results);

$query = CGI->new();

$spelltype = $query->param("spelltype");
@attrnames=$query->param();

grep { $attributes{$_} = $query->param($_); } @attrnames;

if(!($attributes{"firstname"} && $attributes{"lastname"}) ||
   ($spelltype eq 'love' &&
    !($attributes{"targetfirstname"} && $attributes{"targetlastname"}))) {
 print $query->header(), <<EOT;
<title>ERROR</title>
<h1>ERROR: Fields missing!</h1>
<p>
You need to enter the First and Last name of the person to cast the
spell upon, and the First and Last name of the person they should fall
in love with.
EOT
 exit(0);
}

open(TEMPLATES, "spell.dat") || die("Can't open spell.dat");
undef $/;
@templates = map { [ split(/[ \n]+/, $_, 3) ]; } split(/%%\n/, <TEMPLATES>);
close(TEMPLATES);

@results = ();
foreach my $attrname (@attrnames) {
 @candidates = map { $_->[2]; }
		grep { $spelltype =~ /$_->[0]/  &&
			$_->[1] =~ /^$attrname/ &&
			!(grep { !$query->param($_); } split(/,/, $_->[1])); } 
			@templates;
 if(@candidates) {
  $template = HTML::Template->new(scalarref => 
					\$candidates[int(rand(@candidates))],
					die_on_bad_params => 0);
  grep { $template->param($_, $attributes{$_}); } @attrnames;
  push(@results, $template->output());
 }
}

fyshuffle(\@results);

$template = HTML::Template->new(filename => 'spell.tmpl',
				die_on_bad_params => 0);
grep { $template->param($_, $attributes{$_}); } @attrnames;
$template->param("story", join("  ", @results));

print $query->header(), $template->output(), "\n";
exit(0);

sub fyshuffle {
 my($array) = shift;
 my $i;

 for($i = @$array; --$i;) {
  my($j) = int(rand($i+1));
  next if $i == $j;
  @$array[$i,$j] = @$array[$j,$i];
 }
}

